package com.jclark.xsl;

class AnyLevelNumberAction implements Action {
  private Matchable count;
  private Matchable from;
  private NumberListFormatTemplate formatTemplate;

  AnyLevelNumberAction(Matchable count, Matchable from, NumberListFormatTemplate formatTemplate) {
    this.count = count;
    this.from = from;
    this.formatTemplate = formatTemplate;
  }

  public void invoke(ProcessContext context, Node node, Result result) throws XSLException {
    NumberListFormat format = formatTemplate.instantiate(context, node);
    Node root = node;
    for (;;) {
      Node tem = root.getParent();
      if (tem == null)
        break;
      root = tem;
    }
    int n = 0;
    if (count != null || node.getType() == Node.ELEMENT) {
      for (NodeIterator iter = new SubtreeNodeIterator(root);;) {
	Node tem = iter.next();
	if (tem == null)
	  break;
	if (tem.equals(node))
	  break;
	if (from != null && from.matches(context, tem))
	  n = 0;
	else if (count == null) {
	  if (node.getName().equals(tem.getName()) && tem.getType() == Node.ELEMENT)
	    n++;
	}
	else if (count.matches(context, tem))
	  n++;
      }
    }
    result.characters(format.getPrefix(0));
    result.characters(format.formatNumber(0, n + 1));
    result.characters(format.getSuffix());
  }
}
