package com.jclark.xsl;

class ComposeNodeIterator implements NodeIterator {
  private ProcessContext context;
  private NodeIterator iter1;
  private NodeIterator iter2;
  private Query query2;

  ComposeNodeIterator(ProcessContext context, NodeIterator iter1, Query query2) {
    this.context = context;
    this.iter1 = iter1;
    this.query2 = query2;
    this.iter2 = new NullNodeIterator();
  }

  public Node next() {
    for (;;) {
      Node node = iter2.next();
      if (node != null)
	return node;
      node = iter1.next();
      if (node == null)
	break;
      iter2 = query2.select(context, node);
    }
    return null;
  }
}