package com.jclark.xsl;

import java.io.OutputStream;
import java.io.IOException;

public class IndentResultImpl extends ResultImpl {
  private boolean inPcdataChunk = true; // avoid newline before first tag

  public IndentResultImpl(OutputStream out) throws IOException {
    super(out);
  }

  public void characters(String str) throws XSLException {
    if (str.length() > 0) {
      super.characters(str);
      inPcdataChunk = true;
    }
  }

  protected void markup() throws XSLException {
    if (inPcdataChunk)
      inPcdataChunk = false;
    else
      super.characters("\n");
  }

  public void finish() throws XSLException {
    markup();
    super.finish();
  }
}
    
