package com.jclark.xsl;

class LastOfTypeQualifier extends Qualifier {
  private boolean negated;
  LastOfTypeQualifier(boolean negated, Qualifier next) {
    super(next);
    this.negated = negated;
  }
  boolean matches(ProcessContext context, Node node, int maxAncestors) {
    Name name = node.getName();
    for (NodeIterator iter = node.getFollowingSiblings(true);;) {
      node = iter.next();
      if (node == null)
	break;
      if (node.getType() == Node.ELEMENT && node.getName().equals(name))
	return negated ? true : false;
    }
    return negated ? false : true;
  }
}
