package com.jclark.xsl;

class OnlyOfTypeQualifier extends Qualifier {
  private boolean negated;
  OnlyOfTypeQualifier(boolean negated, Qualifier next) {
    super(next);
    this.negated = negated;
  }
  boolean matches(ProcessContext context, Node node, int maxAncestors) {
    Name name = node.getName();
    for (NodeIterator iter = node.getParent().getChildren(true);;) {
      Node tem = iter.next();
      if (tem == null)
	break;
      if (tem.getType() == Node.ELEMENT && tem.getName().equals(name) && !tem.equals(node))
	return negated ? true : false;
    }
    return negated ? false : true;
  }
}
