package com.jclark.xsl;

abstract class QualifiedPattern extends SimplePattern implements Matcher {
  private Qualifier qualifier;

  QualifiedPattern(Qualifier qualifier) {
    this.qualifier = qualifier;
  }

  public boolean matches(ProcessContext context, Node node, int maxAncestors) {
    for (Qualifier tem = qualifier; tem != null; tem = tem.getNext())
      if (!tem.matches(context, node, maxAncestors))
	return false;
    return true;
  }

  public int getSpecificity() {
    int n = 0;
    for (Qualifier tem = qualifier; tem != null; tem = tem.getNext())
      n += tem.getSpecificity();
    return n;
  }

  public byte getMatchNodeType() {
    return Node.ELEMENT;
  }
}
