package com.jclark.xsl;

abstract class SimplePattern implements SubQuery, Matchable {
  private class Iterator implements NodeIterator {
    ProcessContext context;
    NodeIterator iter;
    Iterator(ProcessContext context, Node node) {
      this.context = context;
      iter = node.getChildren(true);
    }
    public Node next() {
      for (;;) {
	Node tem = iter.next();
	if (tem == null)
	  break;
	if (matches(context, tem))
	  return tem;
      }
      return null;
    }
  }

  public NodeIterator select(ProcessContext context, Node node) {
    return new Iterator(context, node);
  }

  public SubQuery createUnion(SubQuery query) {
    if (query instanceof Matchable) {
      return new OrPattern(this, (Matchable)query);
    }
    return null;
  }

  public boolean matches(ProcessContext context, Node node) {
    return matches(context, node, Integer.MAX_VALUE);
  }

}
