package com.jclark.xsl;

class SubtreeNodeIterator implements NodeIterator {
  private int depth;
  private NodeIterator iter;
  private Node cur;
  SubtreeNodeIterator(Node node) {
    depth = 0;
    iter = node.getChildren(true);
    cur = node;
  }

  public Node next() {
    Node tem = cur;
    for (;;) {
      Node node = iter.next();
      if (node != null) {
	++depth;
	cur = node;
	iter = node.getChildren(true);
	return tem;
      }
      else {
	if (depth == 0)
	  break;
	depth--;
	iter = cur.getFollowingSiblings(true);
	cur = cur.getParent();
      }
    }
    cur = null;
    return tem;
  }
}
